/**
 * jsbootstrap - show tooltips/popovers,  requires Bootstrap V5 Javascript libraries)
 * 
 * @author Joachim Schmidt - joachim.schmidt@jschmidt-systemberatung.de
 * @copyright Copyright (C) 2022 Joachim Schmidt. All rights reserved.
 * @license GNU/GPL
 */
function createjsTips(position, trigger, delay, animation) {
	jQuery.noConflict();

	jQuery(".jmootipper")
			.each(
					function() {
						var $pElem = jQuery(this);
						var tip = $pElem.attr("id");
						var width = getPopOption($pElem.attr("id"), 'width');
						if (width != "auto")
						 width += "px";	
						//alert(tip + ':' + getPopOption($pElem.attr("id"), 'position'));
                         var options = {
									html : true,
									delay: delay,
									animation: animation,
									trigger : getPopOption($pElem.attr("id"), 'trigger') || trigger,
									placement : getPopOption($pElem.attr("id"), 'position') || position,
									title : getPopOption($pElem.attr("id"), 'title') || '',
									content : getPopContent($pElem.attr("id")),
									sanitize : false,
									template : '<div class="popover" style="width: auto;"><div class="popover-arrow"></div><h3 class="popover-header"></h3><div class="popover-body"  style="width:' + width +';"></div></div>' 
									}							
					    var tip = new bootstrap.Popover($pElem, options);					     
					});
};

function isMobile() {
		
	var up = navigator.userAgent.toLowerCase();
	var isMobilePlatform = /(iPad|iPhone|iPod|android|webos|cros|cromium)/i.test(up);
	if (isMobilePlatform)
	 return true;
	
	var ua = navigator.userAgent;
	var isKindle = /(Kindle|Silk|KFTT|KFOT|KFJWA|KFJWI|KFSOWI|KFTHWA|KFTHWI|KFAPWA|KFAPWI)/i.test(ua);
	if (isKindle)
	 return true;
	
	return false;	
}
 
function isJSON(data) {
	var isJson = false;
	try {
		var json = jQuery.parseJSON(data);
		isJson = typeof json === 'object';
	} catch (ex) {
		return false;
	}
	return isJson;
};

function getPopOption(target, option) {
	
	if (option == "trigger" && isMobile())
	 return "click";
	
    var options = jQuery("#" + target + "_content > div.tooltipOptions").text();

	try {
		var parms = JSON.parse(options);
		
		if (option == "trigger")
		  return (parms.trigger);

		if (option == "position")
		{	
		  if (parms.autoposition == "1")
		    return 'auto';
		  else
		    return parms.position;
		}
		
		if (option == "title")
		  return (parms.title);
		if (option == "width")
		  return (parms.width || 'auto');
	} catch (err) {
		//alert ('Invalid Tooltip Options: ' + err.message);
		return null;
	}
	return null;
};

function getPopContent(target) {

	var content = jQuery("#" + target + "_content > div.tooltipContent").html();
	
	if (content.indexOf('"ajax"') == -1)
		return content;	
	if (isJSON(content) == false)
		return "not json";
	else {
		var ajaxurl = jQuery.parseJSON(content);
		content = jQuery.ajax({
			url : ajaxurl.ajax,
			type : "GET",
			data : jQuery(this).serialize(),
			dataType : "html",
			async : false
		});
        if (content.statusText == 'OK') 
		  return content.responseText;
        else
          return "Error " +content.status +": " +content.statusText + "<br />" + ajaxurl.ajax;	
	}
};
